package writer2latex.rdf;

import java.io.IOException;
import java.io.InputStream;
import java.util.Iterator;

import org.w3c.dom.Element;

import writer2latex.api.ConverterResult;
import writer2latex.api.OutputFile;
import writer2latex.base.ConverterResultImpl;
import writer2latex.epub.EPUBWriter;
import writer2latex.xhtml.Html5Converter;
import writer2latex.xhtml.Xhtml11Converter;
import writer2latex.xhtml.XhtmlDocument;


public final class RDFConverter extends Xhtml11Converter {

   // Constructor
   public RDFConverter() {
       super();
       this.isRDF = true;
   }

     @Override public ConverterResult convert(InputStream is, String sTargetFileName) throws IOException {
     	setOpenPubStructure(false);
     	ConverterResult xhtmlResult = super.convert(is, "chapter");
    	Iterator<XhtmlDocument> excerptIterator = this.outFiles.iterator();
    	while (excerptIterator.hasNext()) {
    		XhtmlDocument excerptDoc = excerptIterator.next();
    		Element excerptContentNode = excerptDoc.getContentNode();
    		String exPath = excerptContentNode.getAttribute("path");
    		System.out.println(exPath);
    	}
		/*
		 * Iterator<OutputFile> iterator = xhtmlResult.iterator();
		 * while(iterator.hasNext()) { OutputFile of = iterator.next();
		 * System.out.println(of.getFileName()); }
		 */
     	return createPackage(xhtmlResult,sTargetFileName);
     }
     
     @Override public ConverterResult convert(org.w3c.dom.Document dom, String sTargetFileName, boolean bDestructive) throws IOException {
     	ConverterResult xhtmlResult = super.convert(dom, "chapter", bDestructive);
     	//System.out.println(this.outFiles.size());
		/*
		 * Iterator<OutputFile> iterator = xhtmlResult.iterator();
		 * while(iterator.hasNext()) { OutputFile outfile = iterator.next();
		 * System.out.println(outfile.isMasterDocument() + outfile.getFileName()); }
		 */
     	return createPackage(xhtmlResult,sTargetFileName);    	
     }
     
     private ConverterResult createPackage(ConverterResult xhtmlResult, String sTargetFileName) {
     	ConverterResultImpl rdfResult = new ConverterResultImpl();
     	RDFWriter rdfWriter = new RDFWriter(xhtmlResult,sTargetFileName,3,getXhtmlConfig());
     	rdfResult.addDocument(rdfWriter);
     	rdfResult.setMetaData(xhtmlResult.getMetaData());
     	return rdfResult;
     }

 }